codeforces round #426 div 2

A: 如果n%2=0或2就是undefined,否则判一下转一下是否能到达状态

#include<bits/stdc++.h>
using namespace std;
int n;
char s[10], t[10];
int main()
{
    scanf("%s%s%d", s, t, &n);
    if(n % 4 == 0 || n % 4 == 2)
    {
        puts("undefined");
        return 0;
    }
    if((s[0] == ‘^‘ && t[0] == ‘>‘) || (s[0] == ‘>‘ && t[0] == ‘v‘) || (s[0] == ‘v‘ && t[0] == ‘<‘) || (s[0] == ‘<‘ && t[0] == ‘^‘))
    {
        if(n % 4 == 1)
        {
            puts("cw");
            return 0;
        }
        if(n % 4 == 3)
        {
            puts("ccw");
            return 0;
        }
    }
    else
    {
        if(n % 4 == 1)
        {
            puts("ccw");
            return 0;
        }
        else
        {
            puts("cw");
            return 0;
        }
    }
    return 0;
}

B:cf常见套路,开个桶,扫一遍,看有没有超过

#include<bits/stdc++.h>
using namespace std;
int n, k, tot;
char s[1000010];
int t[27], tt[27];
int main()
{
    scanf("%d%d%s", &n, &k, s);
    int len = strlen(s);
    for(int i = 0; i < len; ++i)
    {
        ++t[s[i] - ‘A‘];
        ++tt[s[i] - ‘A‘];
    }
    for(int i = 0; i < len; ++i)
    {
        if(t[s[i] - ‘A‘] == tt[s[i] - ‘A‘]) ++tot;
        if(tot > k)
        {
            puts("YES");
            return 0;
        }
        --t[s[i] - ‘A‘];
        if(t[s[i] - ‘A‘] == 0) --tot;
    }
    puts("NO");
    return 0;
}

C:思维僵化,写了个线性筛。其实我们可以二分,因为a*b肯定是立方数,然后求出gcd,因为gcd至少是x,所以判一下x*x*x==a*b和gcd%x==0就行了,gcd必须包含x,因为我们可以让一个数一直乘k,另一个*k^2,这样gcd=x,否则gcd会比x大,且能整除x

#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
int n;
int main()
{
    scanf("%d", &n);
    while(n--)
    {
        ll a, b, x = 0, l = 0, r = 1000010;
        scanf("%lld%lld", &a, &b);
        while(r - l > 1)
        {
            ll mid = (l + r) >> 1;
            if(mid * mid * mid <= a * b) l = x = mid;
            else r = mid;
        }
        ll t = __gcd(a, b);
        if(x * x * x == a * b && t % x == 0) puts("Yes");
        else puts("No");
    }
    return 0;
}

D:首先可以知道是dp,dp[i][k]表示选到第i个数,分了k段,dp[i][k]=dp[j][k-1]+calc(j+1,i),calc是计算颜色数,那么这里我们用线段树优化一下,算出每个颜色上一次出现的位置,每扫到一个位置,把从这里到上一个位置的dp值+1,也就是说这一段出现了一种新颜色,还有一种做法是整体二分,因为这个式子有决策单调性,那么整体二分直接搞就行了,如果后面的dp值+calc大于之前所有dp+calc,那么之后肯定也会更优,因为再加入颜色,后面的颜色数比之前的少,加入新颜色也肯定比之前优

线段树

#include<bits/stdc++.h>
using namespace std;
const int N = 35010;
int n, K;
int r[N], last[N], dp[N][55], bin[N];
struct seg {
    int tree[N << 2], tag[N << 2];
    void clr()
    {
        tag[1] = -1;
        tree[1] = 0;
    }
    void pushdown(int x)
    {
        if(tag[x] == 0) return;
        if(tag[x] == -1)
        {
            tag[x << 1] = tag[x << 1 | 1] = tag[x];
            tree[x << 1] = tree[x << 1 | 1] = 0;
            tag[x] = 0;
            return;
        }
        tag[x << 1] += tag[x];
        tag[x << 1 | 1] += tag[x];
        tree[x << 1] += tag[x];
        tree[x << 1 | 1] += tag[x];
        tag[x] = 0;
    }
    void update(int l, int r, int x, int a, int b, int delta)
    {
        if(l > b || r < a) return;
        if(l >= a && r <= b)
        {
            tag[x] += delta;
            tree[x] += delta;
            return;
        }
        pushdown(x);
        int mid = (l + r) >> 1;
        update(l, mid, x << 1, a, b, delta);
        update(mid + 1, r, x << 1 | 1, a, b, delta);
        tree[x] = max(tree[x << 1], tree[x << 1 | 1]);
    }
    int query(int l, int r, int x, int a, int b)
    {
        if(l > b || r < a) return 0;
        if(l >= a && r <= b) return tree[x];
        pushdown(x);
        int mid = (l + r) >> 1;
        return max(query(l, mid, x << 1, a, b), query(mid + 1, r, x << 1 | 1, a, b));
    }
} t;
int main()
{
    scanf("%d%d", &n, &K);
    for(int i = 1; i <= n; ++i)
    {
        int c;
        scanf("%d", &c);
        r[i] = last[c];
        last[c] = i;
        if(bin[c] == 0) dp[i][1] = dp[i - 1][1] + 1;
        else dp[i][1] = dp[i - 1][1];
        ++bin[c];
    }
    if(K == 1)
    {
        printf("%d\n", dp[n][1]);
        return 0;
    }
    for(int k = 2; k <= K; ++k)
    {
        t.clr();
        for(int i = k - 1; i <= n; ++i)
        {
            t.update(1, n, 1, max(r[i], k - 1), i - 1, 1);
            dp[i][k] = t.query(1, n, 1, k - 1, i - 1);
            t.update(1, n, 1, i, i, dp[i][k - 1]);
        }
    }
    printf("%d\n", dp[n][K]);
    return 0;
}

tle的整体二分 开了一堆map,t了

#include<bits/stdc++.h>
using namespace std;
const int N = 35010;
int n, k;
int dp[N][60], a[N];
map<int, int> bin;
map<int, int> distinct[N];
int build(int l, int r)
{
    bin.clear();
    distinct[r].clear();
    for(int i = r; i >= l; --i) if(bin.find(a[i]) == bin.end())
    {
        distinct[r][i] = distinct[r][i + 1] + 1;
        bin[a[i]] = 1;
    }
    else distinct[r][i] = distinct[r][i + 1];
}
void divide(int l, int r, int opt_l, int opt_r, int k)
{
    if(l > r) return;
    int mid = (l + r) >> 1, opt_m = opt_l;
    build(opt_l, mid);
    for(int i = opt_l; i <= min(opt_r, mid); ++i)
    {
        int delta = dp[i - 1][k - 1] + distinct[mid][i];
        if(delta > dp[mid][k])
        {
            dp[mid][k] = delta;
            opt_m = i;
        }
    }
    distinct[mid].clear();
    divide(l, mid - 1, opt_l, opt_m, k);
    divide(mid + 1, r, opt_m, opt_r, k);
}
int main()
{
    scanf("%d%d", &n, &k);
    for(int i = 1; i <= n; ++i)
    {
        scanf("%d", &a[i]);
        if(bin[a[i]] == 0) dp[i][1] = dp[i - 1][1] + 1;
        else dp[i][1] = dp[i - 1][1];
        ++bin[a[i]];
    }
    for(int i = 2; i <= k; ++i) divide(k, n, 1, n, i);
    printf("%d\n", dp[n][k]);
    return 0;
}

时间: 2024-10-21 11:22:44

codeforces round #426 div 2的相关文章

Codeforces Round #426 (Div. 2) D. The Bakery(线段树维护dp)

题目链接: Codeforces Round #426 (Div. 2) D. The Bakery 题意: 给你n个数,划分为k段,每段的价值为这一段不同的数的个数,问如何划分,使得价值最大. 题解: 考虑dp[i][j]表示划分为前j个数划分为i段的最大价值,那么这就是一个n*n*k的dp, 考虑转移方程dp[i][j]=max{dp[i][k]+val[k+1][j]},我们用线段树去维护这个max,线段树上每个节点维护的值是dp[i][k]+val[k+1][j],对于每加进来的一个数a

Codeforces Round #426 (Div. 2)A B C题+赛后小结

最近比赛有点多,可是好像每场比赛都是被虐,单纯磨砺心态的作用.最近讲的内容也有点多,即便是点到为止很浅显的版块,刷了专题之后的状态还是~"咦,能做,可是并没有把握能A啊".每场网络赛,我似乎都没用上新学的东西,能用上新学东西的题我A不了...5555555555555555 这场CF,讲真,打的心态爆炸,首先A题无限WA,赛后看下WA的那组数据是输入有一个999999999的样例,死骗子,说好的数据是1e9呢,哪能有数据是1e10-1,于是用long long,一下子Accept接收不

Codeforces Round #426 (Div. 2) C. The Meaningless Game (二分 or pow函数)

Slastyona and her loyal dog Pushok are playing a meaningless game that is indeed very interesting. The game consists of multiple rounds. Its rules are very simple: in each round, a natural number k is chosen. Then, the one who says (or barks) it fast

Codeforces Round #426 (Div. 2) (A B C)

A. The Useless Toy Walking through the streets of Marshmallow City, Slastyona have spotted some merchants selling a kind of useless toy which is very popular nowadays – caramel spinner! Wanting to join the craze, she has immediately bought the strang

Codeforces Round #426 (Div. 1) A.The Meaningless Game (二分+数学)

题目链接: http://codeforces.com/problemset/problem/833/A 题意: 给你 \(a\) 和 \(b\),两个人初始化为 \(1\).两个人其中一方乘以 \(k^2\),另一方就乘以 \(k\).问你能不能达到 \((a,b)\) 这个最终状态. 题解: 设 \(X\), \(P\) 表示两个乘积的集合. 那么,显然: \(S^{2}*P=a\) ------ 1 \(S*P^{2}=b\) ------ 2 所以:\(a*b = S^{3}*P^3\)

Codeforces Round #426 (Div. 2)A. The Useless Toy

题意:4个箭头,给出起始箭头,终始箭头,问经历n次,是由顺时针cw得到,还是逆时针cww得到,如果都可以输出undefined 思路:n%4,就是次数了,再两个方向模拟下 1 #include<bits/stdc++.h> 2 using namespace std; 3 typedef long long ll; 4 const int N=1e5+10; 5 6 int a[6]={0,1,2,3,4}; 7 int main(){ 8 int n; 9 char s1[2],s2[2];

Codeforces Round #426 (Div. 2)C. The Meaningless Game

题意:AB两个人,每一轮,其中一人选择一个数字K,那么A就变成A*k*k,B就变成B*K,给出结果,问是否可能 思路:不管多少轮,A*B结果都是某个数的立方,二分 1 #include<bits/stdc++.h> 2 using namespace std; 3 typedef long long ll; 4 const int N=1e5+10,M=1e6+10,inf=1e9+7,MOD=1e9+7; 5 const ll INF=1e18+10,mod=1e9+7; 6 7 8 int

Codeforces Round #426 (Div. 2)B. The Festive Evening

题意:有26个城门,k个守卫,给出每个城门人进入的顺序,只有当这个城门进入的人是最后一个,该城门的守卫才能去别的城门,问是否有个时间段,守卫不够用 思路:记录起始,模拟下 1 #include<bits/stdc++.h> 2 using namespace std; 3 4 int l[30],r[30]; 5 int b[30]; 6 7 int main(){ 8 int n,m; string s; 9 cin>>n>>m; 10 cin>>s; 1

Codeforces Round #426 (Div. 1) (ABCDE)

1. 833A The Meaningless Game 大意: 初始分数为$1$, 每轮选一个$k$, 赢的人乘$k^2$, 输的人乘$k$, 给定最终分数, 求判断是否成立. 判断一下$a\cdot b$是否是立方数, 以及能否被那个立方的因子整除即可. cbrt竟然有误差, 特判了一下, 好坑 #include <iostream> #include <sstream> #include <algorithm> #include <cstdio> #i